<template>
  <div class="password">
    <p class="title-h2 password--title">
      Veuillez créer un nouveau mot de passe
    </p>
    <a-form
      :colon="false"
      hideRequiredMark
      ref="formRef"
      class="login-form"
      name="custom-validation"
      validateOnRuleChange
      :model="formState"
      :rules="rules"
      @submit.prevent="onSubmit"
    >
      <a-form-item name="pass" label="Mot de passe">
        <a-input-password
          autocomplete="off"
          v-model:value="formState.pass"
          placeholder="************"
        >
          <template #prefix>
            <lock-outlined />
          </template>
        </a-input-password>
        <div class="password--validation">
          <p class="title">Le nouveau mot de passe doit contenir :</p>
          <ul class="password--validation-list">
            <li v-for="(validation, index) in validations" :key="index">
              <check-circle-filled
                v-if="formState.pass.match(validation.pattern)"
              />
              <close-circle-outlined v-else />
              <span class="title">{{ validation.message }}</span>
            </li>
          </ul>
        </div>
      </a-form-item>
      <a-form-item name="checkPass" label="Répeter le mot de passe">
        <a-input-password
          placeholder="************"
          v-model:value="formState.checkPass"
          type="password"
          autocomplete="off"
        >
          <template #prefix>
            <lock-outlined />
          </template>
        </a-input-password>
      </a-form-item>
      <div class="password--error">
        <p class="title" v-for="(error, index) in errors" :key="index">
          {{ error }}
        </p>
      </div>
      <a-button type="primary" block html-type="submit"> Enregistrer </a-button>
    </a-form>
  </div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import { passwordValidator } from '@/shared/composables/passwordValidator';
import { errorValidator } from '@/shared/composables/errorValidator';
import {
  LockOutlined,
  CloseCircleOutlined,
  CheckCircleFilled,
} from '@ant-design/icons-vue';

const formRef = ref();
let { customRules, customValidations, errors, formState } = passwordValidator();
let { getErrorMessages, getErrors, filterArray } = errorValidator();
const rules = customRules;
const validations = customValidations;
const onSubmit = (): void => {
  formRef.value
    .validateFields(Object.keys(rules))
    .then(() => {
      errors.value = [];
      //  send request
    })
    .catch(
      (err: {
        errorFields: { errors: string[]; name: string[]; warnings: string[] }[];
      }) => {
        errors.value = getErrors(err.errorFields);
        errors.value = filterArray(
          errors.value,
          getErrorMessages(customValidations)
        );
      }
    );
};
</script>

<style scoped lang="scss">
@import '@/assets/styles/components/forms';
.password {
  width: 360px;
  text-align: center;
  &--title {
    width: 80%;
    margin: 0 auto 32px;
  }
  &--validation {
    margin-top: 12px;
  }
  &--validation-list {
    @include validation-list;
  }
  &--button {
    color: var(--main-black);
  }
  &--error {
    @include validation-error;
  }
}
</style>
